//very good results Z>10, for 25.05.2012



#include "TH1.h"
#include "TMath.h"
#include "TF1.h"
#include "TLegend.h"
#include "TGraphErrors.h"
#include "TCanvas.h"
#include <stdio.h>
#include <stdlib.h>


Double_t fitf(Double_t *x, Double_t *par){
  Double_t fitVAL = 
    (par[0]*par[0] - par[1] - par[2])/pow(1+par[3]*x[0]*x[0],par[6]) +
    par[1]/pow(1+par[4]*x[0]*x[0],par[7]) +
    par[2]/pow(1+par[5]*x[0]*x[0],par[8]);
  return fitVAL;
}

string sInt(int number)
  {
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
  }
  vector<double>PP[9];
  
  // reading 9 fitting parameters of FormFactor used in G4RayleighAngularGenerator class
	void ReadFit9Parameters()
	{
		std::ostringstream ost;
		for(int i = 0; i<9;i++)
		{
			PP[i].reserve(101);
			ost << "./PP" << i <<".dat";
			std::ifstream fin(ost.str().c_str());
			double x;
			PP[i].push_back(0);
			for(int z = 1; z<=100;z++)
			{
				fin >> x;
				PP[i].push_back(x);
				// cout<<"PP"<<i<<" "<<z<<" "<<PP[i][z]<<endl;;
			}	
			fin.close();
			ost.str("");
			ost.clear();

		}


	}



void fit_formFactor_2014()
{
	gROOT->Reset();
	gStyle->SetOptStat(0);
	gStyle->SetOptFit();
	
	ReadFit9Parameters();
	
	// return;

	Double_t x, y;   
	Double_t x1, x2, y1, y2; 
	Double_t ZZ0[101]={0};   
	Double_t PP0[101]={0};   
	Double_t PP1[101]={0};   
	Double_t PP2[101]={0};   
	Double_t PP3[101]={0};   
	Double_t PP4[101]={0};   
	Double_t PP5[101]={0};   
	Double_t PP6[101]={0};   
	Double_t PP7[101]={0};   
	Double_t PP8[101]={0};
   
	char line[200];  

	Double_t xxx[1000]={0};   
	Double_t yyy[1000]={0};   
	Double_t erx[1000]={0};   
	Double_t ery[1000]={0}; 
	Int_t N=0, nn=0; 
	Int_t k = 0;
	

	for(Int_t i=20; i<=20; i++) 
	{
		vector<double> X;
		vector<double> Y_tab;
		vector<double> Y_fit1; // real fit
		vector<double> Y_fit2; // modified fit after real fit
		vector<double> Y_fit3; // Geant4 fit
		
		vector<double> R_fit1;
		vector<double> R_fit2;
		vector<double> R_fit3;
		k = i;
    // for(Int_t i=82; i<83; i++) {

		Int_t Z=i;
		cout <<  " " << endl;
		cout <<  "Next Element " << endl;
		cout <<  "Element " << Z  << endl;
		TString s = sInt(Z);
		// TString datafile="data/re-ff-" + s + ".dat";
		// string datafile="epics2017/formFactor/re-ff-" + s + ".dat";
		// string datafile="epics2014/formFactor/re-ff-" + s + ".dat";
		TString datafile="epics2014/formFactor/g4/re-ff-" + s + ".dat";
		// string ffdata = datafile; 
    
    //OUT
    //TString ffname = "out_" + s + ".txt";       //output file
    //string fname = ffname;    
    //ofstream fout(fname.c_str(), ios::out);      
  
    //IN
    ifstream  data_file(datafile, ios::in );
    if(data_file.fail()){
      cout << "Error opening data file"  << endl;
    }else cout << "data file " << datafile << " is opened" << endl;

    Int_t pp=0;  // how much points to substract
    data_file.getline(line, 50); //cout << line << endl;
    data_file >> nn ;
    x1 = 1; y1 = 1;
    cout << "number of points: "<<nn << endl;
    Double_t P = 8;
    Double_t P0,P1,P2;
    Double_t lim = Z*Z/pow(2,P);  //* when Z<16, lim < 1
    Double_t limy = 1.e-6;
    // Double_t limy = Z*Z*1.e-15;
    Int_t n1 = 0;
    for (N = 0; N < nn; N++) 
	{
		if(!data_file) break;
		data_file >> x >> y;
		y2 = y*y;
		X.push_back(x);
		Y_tab.push_back(y2);
		// if(x1 == 1)
		// {
			// cout<<N<<" zhuxin----"<<endl;
			// // x1=x;
		// }
	  
      if(x1 == 1 && y2 < lim){cout<<"--stop--"<<endl; x1=x; y1=y2;}   
      x2 = x;
      xxx[N] = x;   
      yyy[N] = y2;   
      erx[N] = 0;   
      ery[N] = y2*0.1*(1. + log10((Z*Z)/y2));
      // ery[N] = y2*0.05;
      if(0 == n1 && y2 < Z*Z*limy) {  n1 = N; cout<<"--test--"<<n1<<endl;}
    }
    Int_t Bin = n1;
    // Bin = n1;
    cout <<  "Bin = " << Bin << ", xxx[Bin-1] = "<<xxx[Bin-1]<<endl;
	
    TCanvas *c = new TCanvas("c","GraphFit",800,50, 1000, 800);  
    // TCanvas *c = new TCanvas("c","GraphFit",.0, xxx[Bin], 1000, 800);  
	c->cd();
    P = 4 - 0.0157*Z;
    Double_t B=(pow(2.0,1.0/P)-1)/(x1*x1);
	
    // P2 = P;
	
    // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    // if (Z>2 && Z<=64){
      // P0 = 0.5*log(yyy[nn-3]/yyy[nn-1])/log(xxx[nn-1]/xxx[nn-3]);
    // }
	// if (Z>2 && Z<=64){
	// if (Z>2 && Z<=64){
	// // if (Z>=1 && Z<=64){
      // // P0 = 0.5*log(yyy[n1-1]/yyy[n1-3])/log(xxx[n1-3]/xxx[n1-1]);
	  // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    
	 // P1 = P0;
    
	// }
	
	// if (Z<=10){
      // //   P0 
      // P2 = P;
      // P1 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    // }else if (Z>10 && Z<=64){
      // P2 = P;
      // P1 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
      // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    // }else{
      // P2 = P;
      // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // P1 = P0;
    // }
	
	if (Z<=10){
        // P0 
      P2 = P;
      P1 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
	  P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    }else if (Z>10 && Z<=64){
      P2 = P;
	  P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // P0 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
	  P1 = 0.5*log(yyy[n1-1]/yyy[n1-3])/log(xxx[n1-3]/xxx[n1-1]);
	  // P0 = P1;
     
    }else{
      P2 = P;
      P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // P1 = P0;
	  P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    }
    cout <<  "B= " << B << "  P = " << P << "  P0 = " << P0 
	 << "  P1 = " << P1 << "  P2 = " << P2<< endl;
	 
	 
    if(B < 0.0) { B = 0.0; }
    TF1 *fitFcn = new TF1("fitFcn",fitf,xxx[0],xxx[Bin],9);
    fitFcn->SetParameters(Z,Z*Z/6,Z*Z/6,B,B,B,P2,P1,P0); 
	 // fitFcn->SetParameters(Z,Z,Z,B,B,B,P2,P1,P0); 
    fitFcn->FixParameter(0,Z); 
    fitFcn->SetParLimits(1,Z*Z/10,Z*Z/2); 
    fitFcn->SetParLimits(3,B/1000,B*1000); 
    fitFcn->SetParLimits(4,B/1000,B*1000); 
    fitFcn->SetParLimits(6,P2/2,P2*2); 
    fitFcn->SetParLimits(7,P1/2,P1*2); 
    if(Z<=2){
      fitFcn->FixParameter(2,0); 
      fitFcn->FixParameter(5,B); 
      fitFcn->FixParameter(8,P0);  
    } else {
      fitFcn->SetParLimits(2,0,Z*Z/2); 
      fitFcn->SetParLimits(5,B/1000,B*1000); 
      fitFcn->SetParLimits(8,P0/2,P0*2); 
    }

    // c->SetLogy(1);
    // c->SetLogx(1);
	gPad->SetLogy();
	gPad->SetLogx();

    // TGraphErrors *gr = new TGraphErrors(nn, xxx, yyy, erx, ery); 
    TGraphErrors *gr = new TGraphErrors(Bin, xxx, yyy, erx, ery); 
    gr->SetTitle("FF Fit");
    gr->Draw("ALP*");
    gr->Fit(fitFcn);
	// return;
	
	
    Double_t p1 =  fitFcn->GetParameter(1);
    if(p1 < 1.e-8) { p1 = 0;}
    Double_t p2 =  fitFcn->GetParameter(2);
    if(p2 < 1.e-8) { p2 = 0;}
    Double_t p0 =  Z*Z - p1 - p2;
    Double_t p3 =  fitFcn->GetParameter(3);
    Double_t p4 =  fitFcn->GetParameter(4);
    Double_t p5 =  fitFcn->GetParameter(5);
    Double_t p6 =  fitFcn->GetParameter(6);
    Double_t p7 =  fitFcn->GetParameter(7);
    Double_t p8 =  fitFcn->GetParameter(8);

    if(p1 < 1.e-5) { p1 = 0;}
    if(p2 < 1.e-5) { p2 = 0;}

    PP0[Z]=p0;
    PP1[Z]=p1; 
    PP2[Z]=p2; 
    PP3[Z]=p3;
    PP4[Z]=p4; 
    PP5[Z]=p5; 
    PP6[Z]=p6; 
    PP7[Z]=p7;
    PP8[Z]=p8;


    c->Update();
    fitFcn->SetParameters(Z,PP1[Z],PP2[Z],PP3[Z],PP4[Z],PP5[Z],PP6[Z],PP7[Z],PP8[Z]); 

    fitFcn->FixParameter(0,Z); 
    fitFcn->SetParLimits(1,PP1[Z]/2,Z*Z/2); 
    fitFcn->SetParLimits(2,PP2[Z]/2,Z*Z/2); 
    fitFcn->SetParLimits(3,PP3[Z]/1000,PP3[Z]*1000); 
    fitFcn->SetParLimits(4,PP4[Z]/1000,PP4[Z]*1000); 
    fitFcn->SetParLimits(5,PP5[Z]/1000,PP5[Z]*1000); 
    fitFcn->SetParLimits(6,PP6[Z]/2,PP6[Z]*2); 
    fitFcn->SetParLimits(7,PP7[Z]/2,PP7[Z]*2); 
    fitFcn->SetParLimits(8,PP8[Z]/2,PP8[Z]*2); 
    if(Z<=2){
      fitFcn->FixParameter(2,0); 
      fitFcn->FixParameter(5,p5); 
      fitFcn->FixParameter(8,p8);  
    }
    if(p1 < 1.e-5) { 
      fitFcn->FixParameter(1,0); 
      fitFcn->FixParameter(4,p4); 
      fitFcn->FixParameter(7,p7);  
    }
    if(p2 < 1.e-5) { 
      fitFcn->FixParameter(2,0); 
      fitFcn->FixParameter(5,p5); 
      fitFcn->FixParameter(8,p8);  
    }
    gr->Fit(fitFcn);
 

	p1 =  fitFcn->GetParameter(1);
	if(p1 < 1.e-5) { p1 = 0;}
	p2 =  fitFcn->GetParameter(2);
	if(p2 < 1.e-5) { p2 = 0;}
	p0 =  Z*Z - p1 - p2;
	p3 =  fitFcn->GetParameter(3);
	p4 =  fitFcn->GetParameter(4);
	p5 =  fitFcn->GetParameter(5);
	p6 =  fitFcn->GetParameter(6);
	p7 =  fitFcn->GetParameter(7);
	p8 =  fitFcn->GetParameter(8);

	PP0[Z]=p0;
	PP1[Z]=p1; 
	PP2[Z]=p2; 
	PP3[Z]=p3;
	PP4[Z]=p4; 
	PP5[Z]=p5; 
	PP6[Z]=p6; 
	PP7[Z]=p7;
	PP8[Z]=p8;
		
		

		gr->SetLineColor(kBlue);
		// gr->Draw("ALP* SAME");
		
		TString name="plots/Fit_FF_2014/Ahisto_" + s + ".gif";
		c->Print(name);
		delete c;
		c = NULL;
		
		 TCanvas *mycanvas = new TCanvas("mycanvas",s,800,50, 1000, 800);
		mycanvas->Divide(1,2);
		mycanvas->cd(1);
		gPad->SetLogy();
		gPad->SetLogx();
		cout<<"--real fit: "<<fitFcn->GetParameter(0)<<" "<<fitFcn->GetParameter(1)<<" "<<fitFcn->GetParameter(2)<<endl;
		cout<<"--modified fit: "<<p0<<" "<<p1<<" "<<p2<<endl;
		cout<<"PP0 = "<<PP[0][Z]<<" PP1 = "<<PP[1][Z]<<" PP2 = "<<PP[2][Z]<<" PP3 = "<<PP[3][Z]<<
		" PP4 = "<<PP[4][Z]<<" PP5 = "<<PP[5][Z]<<" PP6 = "<<PP[6][Z]<<" PP7 = "<<PP[7][Z]<<" PP8 = "<<PP[8][Z]<<endl;
		
		for(int i = 0; i< nn; i++)
		{
			
			double y11 = fitFcn->Eval(X[i]); //real fit
			// double PPP0 = fitFcn->GetParameter(0);
			// double y0 = (PPP0*PPP0 - PP1[Z] - PP2[Z])/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						// PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						// PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
				
			// modified fit
			double y2 = PP0[Z]/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
						
			// double y3 = (PP[0][Z]*PP[0][Z] - PP[1][Z] - PP[2][Z])/pow(1+PP[3][Z]*X[i]*X[i],PP[6][Z]) +
						// PP[1][Z]/pow(1+PP[4][Z]*X[i]*X[i],PP[7][Z]) +
						// PP[2][Z]/pow(1+PP[5][Z]*X[i]*X[i],PP[8][Z]);
						
			double y3 = PP[0][Z]/pow(1+PP[3][Z]*X[i]*X[i],PP[6][Z]) +
						PP[1][Z]/pow(1+PP[4][Z]*X[i]*X[i],PP[7][Z]) +
						PP[2][Z]/pow(1+PP[5][Z]*X[i]*X[i],PP[8][Z]);
						
						
			
			double r1 = (y11-Y_tab[i])/Y_tab[i]*100;
			double r2 = (y2-Y_tab[i])/Y_tab[i]*100;
			double r3 = (y3-Y_tab[i])/Y_tab[i]*100;
			Y_fit1.push_back(y11);		
			Y_fit2.push_back(y2);
			Y_fit3.push_back(y3);
			R_fit1.push_back(r1);
			R_fit2.push_back(r2);
			R_fit3.push_back(r3);
			// printf("____%d %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y11, y2);
			// printf("____%d %.9e %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y11, y0, y2);
			// printf("____%d %.9e %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y11, y2, y3);
			// printf("---%d %.9e %.9e %.9e %.9e\n", i, X[i], r1, r2, r3);
		}
		TGraph *graph0 = new TGraph(Bin,X.data(),Y_tab.data());
		TGraph *graph1 = new TGraph(Bin,X.data(),Y_fit1.data());
		TGraph *graph2 = new TGraph(Bin,X.data(),Y_fit2.data());
		TGraph *graph3 = new TGraph(Bin,X.data(),Y_fit3.data());
		
		auto mg = new TMultiGraph();
		
		
		graph2->SetMarkerStyle(24);  // modified fit
		graph2->SetMarkerSize(1.3);
		graph2->SetMarkerColor(kRed);
		//graph2->SetLineWidth(2);
		graph2->SetLineColor(kRed);	
		mg->Add(graph2);
		
		graph1->SetMarkerStyle(24);  // real fit
		graph1->SetMarkerSize(1.0);
		graph1->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph1->SetLineColor(kBlue);	
		mg->Add(graph1);
		
		
		
		
		
		
		graph3->SetMarkerStyle(20);  // geant4 fit
		graph3->SetMarkerSize(0.7);
		graph3->SetMarkerColor(kYellow);
		//graph2->SetLineWidth(2);
		graph3->SetLineColor(kYellow);	
		mg->Add(graph3);
		
		graph0->SetMarkerStyle(20);  // tabulated data
		graph0->SetMarkerSize(0.4);
		graph0->SetMarkerColor(kTeal+4);
		//graph1->SetLineWidth(2);
		graph0->SetLineColor(kTeal+4);	
		mg->Add(graph0);
		
		mg->Draw("AP");
		TString title = "EPDL2014: fitted FF(square) VS tabulated FF(square) for element " + s;
		mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Momentum transfer");
		mg->GetYaxis()->SetTitle("Square of FF");
		
		
		TLegend* leg = new TLegend(0.15,0.7,0.35,0.9);
		// leg->SetTextAlign(12);
		// leg->SetFillColor(0);
		leg->SetFillStyle(0);		
		leg->SetTextSize(0.04);
		
		TString rname10 = "Tabulated data";
		TString rname11 = "Real fit";
		TString rname12 = "Modified fit";
		TString rname13 = "Geant4 fit";
		
		leg->AddEntry(graph0,rname10);
		leg->AddEntry(graph1,rname11);
		// leg->AddEntry(graph14,rname14);
		
		leg->AddEntry(graph2,rname12);
		leg->AddEntry(graph3,rname13);
		// leg->AddEntry(graph24,rname24);
		
		//leg->DrawClone("Same");
		leg->Draw();
		
		
		
		
		
		//*************************************************
		mycanvas->cd(2);
		// gPad->SetLogy();
		gPad->SetLogx();
		
		TGraph *ratio1 = new TGraph(Bin,X.data(),R_fit1.data());
		TGraph *ratio2 = new TGraph(Bin,X.data(),R_fit2.data());
		TGraph *ratio3 = new TGraph(Bin,X.data(),R_fit3.data());
		
		// TGraph *ratio1 = new TGraph(nn,X.data(),R_fit1.data());
		// TGraph *ratio2 = new TGraph(nn,X.data(),R_fit2.data());
		// TGraph *ratio3 = new TGraph(nn,X.data(),R_fit3.data());
		
		auto mg1 = new TMultiGraph();
		
		
		
		
		
		ratio2->SetMarkerStyle(24); 
		ratio2->SetMarkerSize(1.3);
		ratio2->SetMarkerColor(kRed);
		//ratio2->SetLineWidth(2);
		ratio2->SetLineColor(kRed);	
		mg1->Add(ratio2);
		
		ratio1->SetMarkerStyle(24);  
		ratio1->SetMarkerSize(1.);
		ratio1->SetMarkerColor(kBlue);
		//ratio1->SetLineWidth(2);
		ratio1->SetLineColor(kBlue);	
		mg1->Add(ratio1);
		
		ratio3->SetMarkerStyle(20);  
		ratio3->SetMarkerSize(0.7);
		ratio3->SetMarkerColor(kYellow);
		//ratio3->SetLineWidth(2);
		ratio3->SetLineColor(kYellow);	
		mg1->Add(ratio3);
		
		
		mg1->Draw("AP");
		TString title1 = "EPDL2014: Relative difference of real fitted FF(square) + modified FF(square) for element " + s;
		mg1->SetTitle(title);		
		mg1->GetXaxis()->SetTitle("Momentum transfer");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		TLegend* leg1 = new TLegend(0.15,0.7,0.35,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
		// TString rname11 = "Real fit";
		// TString rname12 = "Modified fit";
		
		leg1->AddEntry(ratio1,rname11);
		// leg1->AddEntry(graph14,rname14);
		
		leg1->AddEntry(ratio2,rname12);
		leg1->AddEntry(ratio3,rname13);
		// leg1->AddEntry(graph24,rname24);
		
		//leg1->DrawClone("Same");
		leg1->Draw();
		
		
		TString name1="plots/Fit_FF_compare_2014/Ahisto_" + s + ".gif";
		mycanvas->Print(name1);
		// delete mycanvas;
		// mycanvas = NULL;
		data_file.close();
  }

	// cout << " " << endl;

	// cout << "Main output of Parameters " << endl;
	// //cout << "Main output of Parameters " << endl;
	// //cout << "Main output of Parameters " << endl;

	// cout << "const G4double" << endl;
	cout << "G4RayleighAngularGenerator::PP0[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	for(int i=k; i<=k; i++) {
	// for(int i=1; i<=1; i++) {
	// cout <<  PP0[i] << ", " ;
	printf("%.6e ", PP0[i]);
	}
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP0[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

 ////////////////////////////////////////////////////////

 
	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP1[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP1[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP2[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP2[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP3[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP3[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP4[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP4[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP5[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP5[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP6[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP6[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP7[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	// for(i=21; i<31; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP7[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 

	// cout << "" << endl;
	// cout << "const G4double" << endl;
	// cout << "G4RayleighAngularGenerator::PP8[101] = { 0, " << endl;
	// for(i=1; i<11; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 1-11 " << endl;

	// for(i=11; i<21; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 11-21 " << endl;

	for(int i=k; i<=k; i++) {
	// for(int i=1; i<=1; i++) {
	// cout <<  PP8[i] << ", " ;
	printf("%.6e ", PP8[i]);
	}
	// cout <<  "    // 21-31 " << endl;

	// for(i=31; i<41; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 31-41 " << endl;

	// for(i=41; i<51; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 41-51 " << endl;

	// for(i=51; i<61; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 51-61 " << endl;

	// for(i=61; i<71; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 61-71 " << endl;

	// for(i=71; i<81; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 71-81 " << endl;

	// for(i=81; i<91; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 81-91 " << endl;

	// for(i=91; i<101; i++) {
	// cout <<  PP8[i] << ", " ;
	// }
	// cout <<  "    // 91-101 " << endl;
	// cout << "};" << endl; 



}





